Index: trunk/src/libs/xpcom18a4/ipc/ipcd/client/public/ipcdclient.h
===================================================================
--- trunk/src/libs/xpcom18a4/ipc/ipcd/client/public/ipcdclient.h	(revision 102390)
+++ trunk/src/libs/xpcom18a4/ipc/ipcd/client/public/ipcdclient.h	(revision 102392)
@@ -54,5 +54,5 @@
 #include "ipcIClientObserver.h"
 
-#include <iprt/types.h>
+#include "prinrval.h"
 
 /* This API is only provided for the extensions compiled into the IPCDC
@@ -240,5 +240,5 @@
   ipcIMessageObserver *aObserver = nsnull,
   ipcIMessageObserver *aConsumer = nsnull,
-  RTMSINTERVAL        aTimeout = RT_INDEFINITE_WAIT
+  PRIntervalTime       aTimeout = PR_INTERVAL_NO_TIMEOUT
 );
 
Index: trunk/src/libs/xpcom18a4/ipc/ipcd/client/src/ipcService.cpp
===================================================================
--- trunk/src/libs/xpcom18a4/ipc/ipcd/client/src/ipcService.cpp	(revision 102390)
+++ trunk/src/libs/xpcom18a4/ipc/ipcd/client/src/ipcService.cpp	(revision 102392)
@@ -105,5 +105,5 @@
 {
     return IPC_WaitMessage(aSenderID, aTarget, aObserver, nsnull,
-                           aTimeout);
+                           PR_MillisecondsToInterval(aTimeout));
 }
 
Index: trunk/src/libs/xpcom18a4/ipc/ipcd/client/src/ipcdclient.cpp
===================================================================
--- trunk/src/libs/xpcom18a4/ipc/ipcd/client/src/ipcdclient.cpp	(revision 102390)
+++ trunk/src/libs/xpcom18a4/ipc/ipcd/client/src/ipcdclient.cpp	(revision 102392)
@@ -66,5 +66,5 @@
 /* ------------------------------------------------------------------------- */
 
-#define IPC_REQUEST_TIMEOUT (30 * RT_MS_1SEC)
+#define IPC_REQUEST_TIMEOUT PR_SecondsToInterval(30)
 
 /* ------------------------------------------------------------------------- */
@@ -307,5 +307,5 @@
 static nsresult
 WaitTarget(const nsID           &aTarget,
-           RTMSINTERVAL         aTimeout,
+           PRIntervalTime        aTimeout,
            ipcMessage          **aMsg,
            ipcMessageSelector    aSelector = nsnull,
@@ -323,9 +323,9 @@
   PRBool isIPCMTarget = aTarget.Equals(IPCM_TARGET);
 
-  uint64_t timeStart = RTTimeMilliTS();
-  uint64_t timeEnd;
-  if (aTimeout == RT_INDEFINITE_WAIT)
+  PRIntervalTime timeStart = PR_IntervalNow();
+  PRIntervalTime timeEnd;
+  if (aTimeout == PR_INTERVAL_NO_TIMEOUT)
     timeEnd = aTimeout;
-  else if (aTimeout == 0)
+  else if (aTimeout == PR_INTERVAL_NO_WAIT)
     timeEnd = timeStart;
   else
@@ -335,5 +335,5 @@
     // if overflowed, then set to max value
     if (timeEnd < timeStart)
-      timeEnd = RT_INDEFINITE_WAIT;
+      timeEnd = PR_INTERVAL_NO_TIMEOUT;
   }
 
@@ -440,5 +440,5 @@
 #endif /* VBOX */
 
-    uint64_t t = RTTimeMilliTS();
+    PRIntervalTime t = PR_IntervalNow();
     if (t > timeEnd) // check if timeout has expired
     {
@@ -1081,5 +1081,5 @@
                 ipcIMessageObserver *aObserver,
                 ipcIMessageObserver *aConsumer,
-                RTMSINTERVAL        aTimeout)
+                PRIntervalTime       aTimeout)
 {
   NS_ENSURE_TRUE(gClientState, NS_ERROR_NOT_INITIALIZED);
Index: trunk/src/libs/xpcom18a4/ipc/ipcd/extensions/dconnect/src/ipcDConnectService.cpp
===================================================================
--- trunk/src/libs/xpcom18a4/ipc/ipcd/extensions/dconnect/src/ipcDConnectService.cpp	(revision 102390)
+++ trunk/src/libs/xpcom18a4/ipc/ipcd/extensions/dconnect/src/ipcDConnectService.cpp	(revision 102392)
@@ -96,5 +96,5 @@
 //-----------------------------------------------------------------------------
 
-#define DCON_WAIT_TIMEOUT RT_INDEFINITE_WAIT
+#define DCON_WAIT_TIMEOUT PR_INTERVAL_NO_TIMEOUT
 
 //-----------------------------------------------------------------------------
@@ -1281,9 +1281,9 @@
     {
         uClient = aClient;
-        uTimestamp = RTTimeMilliTS();
+        uTimestamp = PR_IntervalNow();
     }
 
     PRUint32 uClient;
-    uint64_t uTimestamp;
+    PRIntervalTime uTimestamp;
 } ClientDownInfo;
 typedef std::map<PRUint32, ClientDownInfo *> ClientDownMap;
@@ -1326,5 +1326,5 @@
         // Insert new client down information. Start by expiring outdated
         // entries and free one element if there's still no space (if needed).
-        uint64_t now = RTTimeMilliTS();
+        PRIntervalTime now = PR_IntervalNow();
         while (!g_ClientDownList.empty())
         {
@@ -1332,6 +1332,6 @@
             PRInt64 diff = (PRInt64)now - cInfo->uTimestamp;
             if (diff < 0)
-                diff += (PRInt64)((uint64_t)-1) + 1;
-            if (diff > 15 * 60 * RT_MS_1SEC)
+                diff += (PRInt64)((PRIntervalTime)-1) + 1;
+            if (diff > PR_SecondsToInterval(15 * 60))
             {
                 g_ClientDownMap.erase(cInfo->uClient);
@@ -3557,6 +3557,7 @@
     mon.Exit();
     {
+      PRUint32 ticks = PR_MillisecondsToInterval(PR_MIN(mWorkers.Count() / 20 + 1, 10));
       nsAutoMonitor workersMon(mWaitingWorkersMon);
-      workersMon.Wait(PR_MIN(mWorkers.Count() / 20 + 1, 10));
+      workersMon.Wait(ticks);
     }
     mon.Enter();
Index: trunk/src/libs/xpcom18a4/ipc/ipcd/extensions/lock/src/ipcLockService.cpp
===================================================================
--- trunk/src/libs/xpcom18a4/ipc/ipcd/extensions/lock/src/ipcLockService.cpp	(revision 102390)
+++ trunk/src/libs/xpcom18a4/ipc/ipcd/extensions/lock/src/ipcLockService.cpp	(revision 102392)
@@ -109,5 +109,5 @@
         do {
             // block the calling thread until we get a response from the daemon
-            rv = IPC_WaitMessage(0, kLockTargetID, this, nsnull, RT_INDEFINITE_WAIT);
+            rv = IPC_WaitMessage(0, kLockTargetID, this, nsnull, PR_INTERVAL_NO_TIMEOUT);
         }
         while (NS_SUCCEEDED(rv) && !pendingLock.complete);
Index: trunk/src/libs/xpcom18a4/ipc/ipcd/extensions/transmngr/src/tmTransactionService.cpp
===================================================================
--- trunk/src/libs/xpcom18a4/ipc/ipcd/extensions/transmngr/src/tmTransactionService.cpp	(revision 102390)
+++ trunk/src/libs/xpcom18a4/ipc/ipcd/extensions/transmngr/src/tmTransactionService.cpp	(revision 102392)
@@ -328,5 +328,5 @@
                   aTrans->GetRawMessageLength());
   if (aSync)
-    IPC_WaitMessage(0, kTransModuleID, nsnull, nsnull, RT_INDEFINITE_WAIT);
+    IPC_WaitMessage(0, kTransModuleID, nsnull, nsnull, PR_INTERVAL_NO_TIMEOUT);
 }
 